//Four.Nine DAT archive(0D??.DAT)
#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <string.h>

void main( int ac, char **av )
{
	FILE				*in;
	FILE				*out;
	unsigned char		tmp[12];
	unsigned char		*buf;
	unsigned char		*filebuf;
	unsigned long		header_length = 0L;
	unsigned int		file_count = 0;
	unsigned long		file_size = 0L;

	char				header_filename[12];
	unsigned long		header_filest = 0L;
	unsigned long		header_fileed = 0L;
	unsigned long		header_filelength = 0L;
	unsigned long		data_st = 0L;
	unsigned long		nowsize = 0L;

	unsigned int		i;

	printf( "Four.Nine DAT File Divider 060208 (c)Fac.KUROHANE\n" );

	if( ac == 1 )
	{
		printf( "usage: DATDIV <filename>\n" );
		return;
	}

	in = fopen( av[1], "rb" );
	if( in == NULL )
	{
		printf( "error: can't open %s\n", av[1] );
		return;
	}

	printf( "filename: %s\n", av[1] );

	fread( tmp, 11, 1, in );
	if( memcmp( av[1], "0D", 2 ))
	{
		printf( "error: not DAT format.\n" );
		goto end2;
	}

	//File size
	fseek( in , 0, SEEK_END );
	file_size = ftell( in );
	printf( "file_size: %lu\n", file_size );

	//File count
	fseek( in , -2, SEEK_END );	
	fread( tmp, 2, 1, in );
	file_count = (( *( unsigned int * )( tmp ) - 0x10 ) / 16 ) - 1;
	printf( "file_count: %d\n", file_count );

	//Header length
	header_length = *( unsigned int * )( tmp ) - 0x10;
	printf( "header_length : %08lX(%ld)\n", header_length, header_length );

	//Header decode
	filebuf = ( unsigned char *)calloc( 1, header_length );
	buf = ( unsigned char *)calloc( 1, header_length );

	fseek( in , -header_length, SEEK_END );
	data_st = ftell( in );
	fread( filebuf, header_length, 1, in );

	for( i = 0; i != header_length; i++ )
	{
		buf[i] = filebuf[i] ^ 0x99;
	}

	free( filebuf );

//	out = fopen( "DECODE_H.BIN", "wb+" );
//	fwrite( buf, header_length, 1, out );
//	fclose( out );

	printf( "\n" );

	for( i = 0; i != file_count; i++ )
	{
		strcpy( header_filename, &buf[i*0x10] );
		header_filest = *( unsigned long *)( buf + (( i * 0x10 ) + 0x0C ));
		if( i == file_count - 1 ) header_fileed = data_st;
		else header_fileed = *( unsigned long *)( buf + (( i * 0x10 ) + 0x1C ));
		header_filelength = header_fileed - header_filest;

		printf( "%-13s %08lX-%08lX (%lu) ",
			header_filename,
			header_filest,
			header_filelength,
			header_filelength
		);

		out = fopen( header_filename, "wb+" );
		if( out == NULL )
		{
			printf( "error: can't write %s\n", header_filename );
			goto end;
		}

		filebuf = ( unsigned char * )calloc( 1, 32768 );	//32k
		nowsize = header_filelength;
		fseek( in, header_filest, SEEK_SET );

		while( !( nowsize < 32769 ))
		{
			fread( filebuf, 32768, 1, in );
			fwrite( filebuf, 32768, 1, out );
			nowsize -= 32768;
			printf( "." );
		}
		fread( filebuf, nowsize, 1, in );
		fwrite( filebuf, nowsize, 1, out );
		printf( ".\n" );
		fclose( out );

		free( filebuf );
	}

	printf( "\n" );
	printf( "complete.\n" );

end:;
	free( buf );

end2:;
	fclose( in );
	return;
}
